#ifndef LIBDUFF_ELEMENT_HPP_INCLUDED
#define LIBDUFF_ELEMENT_HPP_INCLUDED


#include"duff_stream.hpp"
#include"duff_datatype.hpp"
#include"duff_vlint.hpp"
#include"duff_link.hpp"
#include<memory>




namespace libduff{


class
ReferenceCounter
{
  friend class Volume;

  uint32_t  value_=0;

};


using uint = unsigned int;


class
Element
{
  friend class Volume;

  ReferenceCounter  refcounter_;

  DataType  data_type_;

  vlintmax_t  general_i;

  std::unique_ptr<uint8_t[]>  buffer_;

public:
  Element(       );
  Element( int  i);
  Element(uint  i);
  Element(const std::string&  s);
  Element(const void*  ptr, size_t  size);

  Element(const Element&   rhs);
  Element(      Element&&  rhs);


  DataType  get_data_type() const;

  void  set_data_type(DataType  data_type);

  const std::string&  get_identifier() const;


   int   get_int() const;
  uint  get_uint() const;

  void  reset_integer( int  i);
  void  reset_integer(uint  i);

  void  reset_string(const std::string&  s);
  void  reset_binary(const void*  ptr, size_t  size);



  void   read(Stream&  s)      ;
  void  write(Stream&  s) const;

  vlintmax_t  get_general_integer() const;

  const void*  get_buffer() const;

  bool  operator==(const Element&  rhs) const;

  void  print(int  indent) const;

  static void  print_indent(int  n);

};




}




#endif




