#include"duff_link.hpp"




namespace libduff{




Link::
Link(LinkKind  kind, UniqueNumber  target_number):
kind_(kind),
target_number_(target_number)
{
}




bool
Link::
test(LinkKind  kind) const
{
  return(kind_ == kind);
}


LinkKind
Link::
get_kind() const
{
  return kind_;
}


UniqueNumber
Link::
get_target_number() const
{
  return target_number_;
}


void
Link::
set_target_number(UniqueNumber  n)
{
  target_number_ = n;
}


bool
Link::
operator==(const Link&  rhs) const
{
  return((kind_ == rhs.kind_) &&
         (target_number_ == rhs.target_number_));
}


void
Link::
write(Stream&  s) const
{
  put_vlint(s,(int)kind_);

    if(kind_ != LinkKind::null)
    {
      put_vlint(s,target_number_);
    }
}


void
Link::
read(Stream&  s)
{
  kind_ = (LinkKind)get_vlint(s);

    if(kind_ != LinkKind::null)
    {
      target_number_ = get_vlint(s);
    }
}




}




