#include"duff.hpp"




namespace libduff{




Link*
Node::
find_link(const char*  name)
{
  auto  res = links_.find(name);

    if(res != links_.cend())
    {
      return &res->second;
    }


  return nullptr;
}


const Link*
Node::
find_link(const char*  name) const
{
  auto  res = links_.find(name);

    if(res != links_.cend())
    {
      return &res->second;
    }


  return nullptr;
}




Node*
Node::
find_node(const char*  name)
{
  auto  ln = find_link(name);

    if(ln && ln->test(LinkKind::node))
    {
      return &volume_.get_node(ln->get_target_number());
    }


  return nullptr;
}


const Node*
Node::
find_node(const char*  name) const
{
  auto  ln = find_link(name);

    if(ln && ln->test(LinkKind::node))
    {
      return &volume_.get_node(ln->get_target_number());
    }


  return nullptr;
}




Element*
Node::
find_element(const char*  name)
{
  auto  ln = find_link(name);

    if(ln && ln->test(LinkKind::element))
    {
      return &volume_.get_element(ln->get_target_number());
    }


  return nullptr;
}


const Element*
Node::
find_element(const char*  name) const
{
  auto  ln = find_link(name);

    if(ln && ln->test(LinkKind::element))
    {
      return &volume_.get_element(ln->get_target_number());
    }


  return nullptr;
}




}




