#ifndef LIBDUFF_LINK_HPP_INCLUDED
#define LIBDUFF_LINK_HPP_INCLUDED


#include"duff_vlint.hpp"
#include<string>
#include<vector>


namespace libduff{


using UniqueNumber = vlintmax_t;


enum class
LinkKind
{
  null,
  soft,
  node,
  element,

};


class
Link
{
  LinkKind  kind_;

  UniqueNumber  target_number_;

public:
  Link(LinkKind  kind=LinkKind::null, UniqueNumber  target_number=0);


  bool  test(LinkKind  kind) const;

  LinkKind  get_kind() const;

  void  set_target_number(UniqueNumber  n);

  UniqueNumber  get_target_number() const;

  bool  operator==(const Link&  rhs) const;

  void   read(Stream&  s)      ;
  void  write(Stream&  s) const;

};


}




#endif




