#ifndef LIBDUFF_VOLUME_HPP_INCLUDED
#define LIBDUFF_VOLUME_HPP_INCLUDED


#include"duff_element.hpp"
#include"duff_stream.hpp"
#include"duff_link.hpp"
#include"duff_node.hpp"




namespace libduff{


class
Volume
{
  std::string  name_;

  UniqueNumber  last_node_number_;
  UniqueNumber  last_element_number_;

  std::unordered_map<UniqueNumber,Node>        nodes_;
  std::unordered_map<UniqueNumber,Element>  elements_;

public:
  Volume(const char*  name="");
  Volume(Volume&&  rhs);


        Node&  get_node(UniqueNumber  n)      ;
  const Node&  get_node(UniqueNumber  n) const;

        Element&  get_element(UniqueNumber  n)      ;
  const Element&  get_element(UniqueNumber  n) const;

  UniqueNumber     new_node(                  );
  UniqueNumber  new_element(                  );
  UniqueNumber  new_element(Element&&  element);

  void  delete_node(   UniqueNumber  target_number);
  void  delete_element(UniqueNumber  target_number);

  void    refer_node(   UniqueNumber  target_number);
  void  unrefer_node(   UniqueNumber  target_number);
  void    refer_element(UniqueNumber  target_number);
  void  unrefer_element(UniqueNumber  target_number);

  bool  operator==(const Volume&  rhs) const;

  void  write(Stream&  s) const;
  void   read(Stream&  s)      ;

  void  print() const;

};


}




#endif




